/*!
Device Reporter

Copyright 2012 Raising the Floor - International

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        path = require("path"),
        gpii = fluid.registerNamespace("gpii");

    fluid.require("kettle", require);
    fluid.require("./DeviceGet.js", require);

    fluid.defaults("gpii.deviceReporter", {
        gradeNames: ["kettle.app", "autoInit"],
        handlers: {
            deviceGet: {
                route: "/device",
                type: "get"
            }
        },
        installedSolutionsUrl: "",
        root: path.join(__dirname, ".."),
        components: {
            installedSolutionsDataSource: {
                type: "kettle.dataSource.URL",
                options: {
                    gradeNames: ["kettle.dataSource.simpleCallbackWrapper"],
                    url: "{gpii.deviceReporter}.options.installedSolutionsUrl"
                }
            }
        }
    });

    fluid.defaults("gpii.deviceReporter.dev", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        distributeOptions: {
            source: "{that}.options.urlExpanderGradeNames",
            target: "{that urlExpander}.options.gradeNames"
        },
        urlExpanderGradeNames: ["kettle.urlExpander.development"]
    });

})();
