Flow Manager
===

The flow manager is responsible for the overall orchestration of the various subcomponents which comprise the GPII personalization architecture. It:

- is able to be notified by the user listener.
- queries the preferences server for user preferences.
- queries the solutions reporter for available solutions.
- communicates with the matchmaker.
- communicates with the launch manager.

### Dependencies

- [infusion](https://github.com/fluid-project/infusion) framework.

### Installation

Run the following command in your newly checked out universal repository. This
will pull all dependencies that are required by universal.

    npm install

### Flow Manager API

The app currently supports the following urls:

    // LOCAL DEPLOYMENT
    {urlToFlowManager}/user/{userName}/login // GET
    {urlToFlowManager}/user/{uesrName}/logout // GET

    // CLOUD BASED DEPLOYMENT
    {urlToFlowManager}/{userName}/settings/:device // GET
    // where :device is an url encoded {device: "..."} block.

For example:

    {urlToFlowManager}/user/andrei/login // GET
    {urlToFlowManager}/andrei/settings/%7BOS%3A%20%7B%7D%7D // GET with {OS: {}}
    {urlToFlowManager}/user/nisha/logout // GET

### Cloud based flow manager

The cloud based configuration of the flow manager enables web apps to communicate to the GPII architecture components and
to retrieve the relevant settings filtered/mapped based on the user profile, platform and application specification. This
configuration of the flow manager is intended for the apps on platforms without a locally running core framework (like web apps).

The expected payload contains the settings for the particular solution keyed by the solution id. Those settings are
produced by the match maker that matches the supplied device/platform information along with the solutions installed with the
current preferences set. These settings are transformed to be consumed by the actual application. For example:

    {
        "org.gnome.desktop.a11y.magnifier": {
            "mag-factor":2,
            "mouse-tracking":"mouse"
        },
        ...
    }

### Run

To run flow manager app simply type:

    [NODE_ENV={environment}] node node_modules/kettle/lib/init.js path/to/flowManager/configs/folder
    [NODE_ENV={environment}] node node_modules/kettle/lib/init.js path/to/gpii/configs/folder   // That folder contains configs for other configurations that inlcude Flow Manager.

- Default environment is development.
- Path to configs folder can be absolute or relative to the current user directory.

For example:

    node node_modules/kettle/lib/init.js gpii/node_modules/flowManager/configs/
    NODE_ENV=production node node_modules/kettle/lib/init.js /Users/{userName}/universal/gpii/node_modules/flowManager/configs/
    NODE_ENV=fm.ps.sr.dr.mm.development node node_modules/kettle/lib/init.js gpii/configs/
