/**
 GPII Lifecycle Manager POST Handler

 Copyright 2013 OCAD University

 Licensed under the New BSD license. You may not use this file except in
 compliance with this License.

 You may obtain a copy of the License at
 https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        gpii = fluid.registerNamespace("gpii"),
        kettle = fluid.require("kettle", require);

    fluid.defaults("kettle.requests.request.handler.lifecycleManagerStart", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.lifecycleManagerStart",
                args: ["{requestProxy}", "{request}.req.params.token", "{gpii.lifecycleManager}.start", "{request}.req.body"],
                dynamic: true
            }
        }
    });

    fluid.defaults("kettle.requests.request.handler.lifecycleManagerStop", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.lifecycleManagerStop",
                args: ["{requestProxy}", "{request}.req.params.token", "{gpii.lifecycleManager}.stop"],
                dynamic: true
            }
        }
    });

    gpii.lifecycleManagerStart = function (requestProxy, token, start, match) {
        start({
            userToken: token
        }, match, requestProxy.events.onSuccess.fire);
    };

    gpii.lifecycleManagerStop = function (requestProxy, token, stop) {
        stop({
            userToken: token
        }, requestProxy.events.onSuccess.fire);
    };

})();
