/*!
GPII Preferences Server

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        path = require("path"),
        gpii = fluid.registerNamespace("gpii");

    fluid.require("kettle", require);
    fluid.require("./userGet.js", require);
    fluid.require("./userPost.js", require);

    fluid.defaults("gpii.preferencesServer", {
        gradeNames: ["kettle.app", "autoInit"],
        handlers: {
            userGet: {
                route: "/user/:token",
                type: "get"
            },
            userPost: {
                route: "/user/:token",
                type: "post"
            }
        },
        root: path.join(__dirname, ".."),
        userSourceUrl: "",
        components: {
            userSource: {
                type: "kettle.dataSource.CouchDB",
                options: {
                    gradeNames: ["kettle.dataSource.simpleCallbackWrapper"],
                    url: "{gpii.preferencesServer}.options.userSourceUrl",
                    writable: true,
                    termMap: {
                        token: "%token"
                    }
                }
            }
        }
    });

    fluid.defaults("gpii.preferencesServer.dev", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        components: {
            userSource: {
                type: "kettle.dataSource.URL"
            }
        },
        distributeOptions: {
            source: "{that}.options.urlExpanderGradeNames",
            target: "{that urlExpander}.options.gradeNames"
        },
        urlExpanderGradeNames: ["kettle.urlExpander.development"]
    });

})();
