/*!
GPII Preferences Server GET Handler

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        gpii = fluid.registerNamespace("gpii"),
        kettle = fluid.require("kettle", require);

    fluid.defaults("kettle.requests.request.handler.userGet", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.handleUserGet",
                args: ["{requestProxy}", "{request}.req.params.token", "{preferencesServer}.userSource"],
                dynamic: true
            }
        }
    });

    gpii.handleUserGet = function (requestProxy, token, userSource) {
        userSource.get({
            token: token
        }, requestProxy.events.onSuccess.fire);
    };

})();
