/*!
GPII Preferences Server POST Handler

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        uuid = require("node-uuid"),
        gpii = fluid.registerNamespace("gpii"),
        kettle = fluid.require("kettle", require);

    fluid.defaults("kettle.requests.request.handler.userPost", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.handleUserPost",
                args: ["{requestProxy}", "{request}.req", "{preferencesServer}.userSource"],
                dynamic: true
            }
        }
    });

    gpii.handleUserPost = function (requestProxy, req, userSource) {
        userSource.set({
            token: req.params.token || uuid.v4()
        }, req.body, requestProxy.events.onSuccess.fire);
    };

})();
