/*!
  GPII INI Settings Handler

  Copyright 2012 Raising the Floor - International

  Licensed under the New BSD license. You may not use this file except in
  compliance with this License.

  You may obtain a copy of the License at
  https://github.com/gpii/universal/LICENSE.txt
*/

/*global require*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        settingsHandlers = fluid.registerNamespace("gpii.settingsHandlers"),
        parser = fluid.registerNamespace(
            "gpii.settingsHandlers.INISettingsHandler.parser"),
        iniparser = require("ini");

    parser.parse = function (content, options) {
        return iniparser.parse(content, options);
    };

    parser.stringify = function (content, options) {
        return iniparser.stringify(content, null, options);
    };

    /* PUBLIC API FUNCTIONS */
    settingsHandlers.INISettingsHandler.get = settingsHandlers.makeGet(parser);
    settingsHandlers.INISettingsHandler.set = settingsHandlers.makeSet(parser);
}());
