/*!
  GPII JSON Settings Handler

  Copyright 2012 OpenDirective and Raising the Floor - International

  Licensed under the New BSD license. You may not use this file except in
  compliance with this License.

  You may obtain a copy of the License at
  https://github.com/gpii/universal/LICENSE.txt
*/

/*global require*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        settingsHandlers = fluid.registerNamespace("gpii.settingsHandlers"),
        parser = fluid.registerNamespace(
            "gpii.settingsHandlers.JSONSettingsHandler.parser");

    parser.parse = function (content) {
        return JSON.parse(content);
    };

    parser.stringify = function (content) {
        return fluid.prettyPrintJSON(content);
    };

    /* PUBLIC API FUNCTIONS */
    settingsHandlers.JSONSettingsHandler.get = settingsHandlers.makeGet(parser);
    settingsHandlers.JSONSettingsHandler.set = settingsHandlers.makeSet(parser);
}());
