Solutions registry
===

A server app built to be deployed with node.js server that saves and returns (and can be queried) solution records.

### Solutions registry API

The app currently supports the following urls:

    {urlToSolutionsRegistryServer}/solutions/{id} // GET AND POST
    {urlToSolutionsRegistryServer}/solutions?os={os} // GET ONLY
    urlToSolutionsRegistryServer}/solutions?os={os}&version={version} // GET ONLY

For example:

    {urlToSolutionsRegistryServer}/solutions/fluid.uiOptions.linux
    {urlToSolutionsRegistryServer}/solutions?os=linux
    {urlToSolutionsRegistryServer}/solutions?os=linux&version=2.6.27

### Dependencies

[infusion](https://github.com/fluid-project/infusion) framework.

### Installation

Run the following command in your newly checked out universal repository. This
will pull all dependencies that are required by universal.

    npm install

### Run

To run solutions registry app simply type:

    [NODE_ENV={environment}] node node_modules/kettle/lib/init.js path/to/solutionsRegistry/configs/folder

- Default environment is development.
- Path to configs folder can be absolute or relative to the current user directory.

For example:

    node node_modules/kettle/lib/init.js gpii/node_modules/solutionsRegistry/configs/
    node node_modules/kettle/lib/init.js /Users/{userName}/universal/gpii/node_modules/solutionsRegistry/configs/
    NODE_ENV=production node node_modules/kettle/lib/init.js gpii/node_modules/solutionsRegistry/configs/