/*!
GPII Solutions Registry GET Handler

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        gpii = fluid.registerNamespace("gpii"),
        kettle = fluid.require("kettle", require);

    fluid.defaults("kettle.requests.request.handler.solutionGet", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.handleSolutionGet",
                args: ["{request}.req.params.id", "{requestProxy}.", "{solutionsRegistry}.solutionSource"],
                dynamic: true
            }
        }
    });

    gpii.handleSolutionGet = function (id, requestProxy, solutionSource) {
        solutionSource.get({
            id: id
        }, requestProxy.events.onSuccess.fire);
    };

})();