/*!
GPII Preferences Server POST Handler

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        gpii = fluid.registerNamespace("gpii"),
        kettle = fluid.require("kettle", require);

    fluid.defaults("kettle.requests.request.handler.solutionPost", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.handleSolutionPost",
                args: ["{request}.req", "{requestProxy}", "{solutionsRegistry}.solutionSource"],
                dynamic: true
            }
        }
    });

    gpii.handleSolutionPost = function (req, requestProxy, solutionSource) {
        solutionSource.set({
            id: req.params.id
        }, req.body, requestProxy.events.onSuccess.fire);
    };

})();