/*
GPII Preferences Server GET Handler

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        gpii = fluid.registerNamespace("gpii"),
        kettle = fluid.require("kettle", require);

    fluid.defaults("kettle.requests.request.handler.solutionQuery", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        invokers: {
            handle: {
                funcName: "gpii.handleSolutionQuery",
                args: ["{requestProxy}", "{request}.req.query.os", "{solutionsRegistry}.solutionQuerySource"],
                dynamic: true
            }
        }
    });

    gpii.handleSolutionQuery = function (requestProxy, os, solutionQuerySource) {
        if (!os) {
            requestProxy.events.onError.fire({
                isError: true,
                message: "No os specified."
            });
            return;
        }
        solutionQuerySource.get({
            os: os
        }, requestProxy.events.onSuccess.fire);
    };

})();