/*!
GPII Preferences Server

Copyright 2012 OCAD University

Licensed under the New BSD license. You may not use this file except in
compliance with this License.

You may obtain a copy of the License at
https://github.com/gpii/universal/LICENSE.txt
*/

(function () {

    "use strict";

    var fluid = require("infusion"),
        path = require("path"),
        gpii = fluid.registerNamespace("gpii");

    fluid.require("kettle", require);
    fluid.require("./solutionGet.js", require);
    fluid.require("./solutionPost.js", require);
    fluid.require("./solutionQuery.js", require);

    fluid.defaults("gpii.solutionsRegistry", {
        gradeNames: ["kettle.app", "autoInit"],
        handlers: {
            solutionGet: {
                route: "/solution/:id",
                type: "get"
            },
            solutionPost: {
                route: "/solution/:id",
                type: "post"
            },
            solutionQuery: {
                route: "/solution?:query",
                type: "get"
            }
        },
        solutionRegistryUrl: "",
        solutionQueryUrl: "",
        root: path.join(__dirname, ".."),
        components: {
            solutionSource: {
                type: "kettle.dataSource.CouchDB",
                options: {
                    gradeNames: ["kettle.dataSource.simpleCallbackWrapper"],
                    url: "{gpii.solutionsRegistry}.options.solutionRegistryUrl",
                    writable: true,
                    termMap: {
                        id: "%id"
                    }
                }
            },
            solutionQuerySource: {
                type: "kettle.dataSource.CouchDB",
                options: {
                    gradeNames: ["kettle.dataSource.simpleCallbackWrapper"],
                    url: "{gpii.solutionsRegistry}.options.solutionQueryUrl",
                    termMap: {
                        os: "%os"
                    }
                }
            }
        }
    });

    fluid.defaults("gpii.solutionsRegistry.dev", {
        gradeNames: ["autoInit", "fluid.littleComponent"],
        components: {
            solutionSource: {
                type: "kettle.dataSource.URL"
            },
            solutionQuerySource: {
                type: "kettle.dataSource.URL"
            }
        },
        distributeOptions: {
            source: "{that}.options.urlExpanderGradeNames",
            target: "{that urlExpander}.options.gradeNames"
        },
        urlExpanderGradeNames: ["kettle.urlExpander.development"]
    });

})();
